FROM {{ cuda.base_image }}

LABEL maintainer "NVIDIA CORPORATION <cudatools@nvidia.com>"

{% if "flavor" in cuda and cuda.flavor == "l4t" %}
ARG NVIDIA_REQUIRE_JETPACK_HOST_MOUNTS=base-only
ENV NVIDIA_REQUIRE_JETPACK_HOST_MOUNTS ${NVIDIA_REQUIRE_JETPACK_HOST_MOUNTS}

{% endif -%}

RUN apt-get update && apt-get install -y --no-install-recommends \
{% if cuda.os.version in ["18.04", "20.04"] %}
    gnupg2 curl ca-certificates && \
    curl -fsSL {{ cuda.repo_url }}/7fa2af80.pub | apt-key add - && \
    echo "deb {{ cuda.repo_url }} /" > /etc/apt/sources.list.d/cuda.list && \
    {% if cuda.use_ml_repo %}
    echo "deb {{ cuda.ml_repo_url }} /" > /etc/apt/sources.list.d/nvidia-ml.list && \
    {% endif %}
    apt-get purge --autoremove -y curl \
{% elif cuda.os.version == "16.04" %}
    ca-certificates apt-transport-https gnupg-curl && \
    NVIDIA_GPGKEY_SUM=d1be581509378368edeec8c1eb2958702feedf3bc3d17011adbf24efacce4ab5 && \
    NVIDIA_GPGKEY_FPR=ae09fe4bbd223a84b2ccfce3f60f4b3d7fa2af80 && \
    apt-key adv --fetch-keys {{ cuda.repo_url }}/7fa2af80.pub && \
    apt-key adv --export --no-emit-version -a $NVIDIA_GPGKEY_FPR | tail -n +5 > cudasign.pub && \
    echo "$NVIDIA_GPGKEY_SUM  cudasign.pub" | sha256sum -c --strict - && rm cudasign.pub && \
    echo "deb {{ cuda.repo_url }} /" > /etc/apt/sources.list.d/cuda.list && \
    {% if cuda.use_ml_repo %}
    echo "deb {{ cuda.ml_repo_url }} /" > /etc/apt/sources.list.d/nvidia-ml.list && \
    {% endif %}
    apt-get purge --auto-remove -y gnupg-curl \
{% endif %}
    && rm -rf /var/lib/apt/lists/*

ENV CUDA_VERSION {{ cuda.version.release_label }}

{% set cuda_cudart_component_version = cuda.version.major + "-" + cuda.version.minor + "=" + cuda.components.cudart.version -%}

# For libraries in the cuda-compat-* package: https://docs.nvidia.com/cuda/eula/index.html#attachment-a
RUN apt-get update && apt-get install -y --no-install-recommends \
    cuda-cudart-{{ cuda_cudart_component_version }} \
{% if cuda.arch != "arm64" %}
    cuda-compat-{{ cuda.version.major }}-{{ cuda.version.minor }} \
{% endif %}
    && ln -s cuda-{{ cuda.version.major }}.{{ cuda.version.minor }} /usr/local/cuda && \
    rm -rf /var/lib/apt/lists/*

# Required for nvidia-docker v1
RUN echo "/usr/local/nvidia/lib" >> /etc/ld.so.conf.d/nvidia.conf \
    && echo "/usr/local/nvidia/lib64" >> /etc/ld.so.conf.d/nvidia.conf

ENV PATH /usr/local/nvidia/bin:/usr/local/cuda/bin:${PATH}
ENV LD_LIBRARY_PATH /usr/local/nvidia/lib:/usr/local/nvidia/lib64

COPY NGC-DL-CONTAINER-LICENSE /

# nvidia-container-runtime
ENV NVIDIA_VISIBLE_DEVICES all
ENV NVIDIA_DRIVER_CAPABILITIES compute,utility
{% if "requires" in cuda %}
ENV NVIDIA_REQUIRE_CUDA "{{ cuda.requires }}"
{% endif %}
